org.apache.lucene.classification

## Interface Classifier<T>

- All Known Implementing Classes:
    BooleanPerceptronClassifier, CachingNaiveBayesClassifier, KNearestNeighborClassifier, SimpleNaiveBayesClassifier

      public interface Classifier<T>

  A classifier, see `http://en.wikipedia.org/wiki/Classifier_(mathematics)`, which assign classes of type `T`
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClassificationResult<T>` | `assignClass(String text)` Assign a class (with score) to the given text String
    `List<ClassificationResult<T>>` | `getClasses(String text)` Get all the classes (sorted by score, descending) assigned to the given text String.
    `List<ClassificationResult<T>>` | `getClasses(String text, int max)` Get the first `max` classes (sorted by score, descending) assigned to the given text String.
    `void` | `train(LeafReader leafReader, String[] textFieldNames, String classFieldName, Analyzer analyzer, Query query)` Train the classifier using the underlying Lucene index
    `void` | `train(LeafReader leafReader, String textFieldName, String classFieldName, Analyzer analyzer)` Train the classifier using the underlying Lucene index
    `void` | `train(LeafReader leafReader, String textFieldName, String classFieldName, Analyzer analyzer, Query query)` Train the classifier using the underlying Lucene index

- - ### Method Detail

    - #### assignClass

          ClassificationResult<T> assignClass(String text)
                                              throws IOException

      Assign a class (with score) to the given text String
      Parameters:
        `text` - a String containing text to be classified
      Returns:
        a `ClassificationResult` holding assigned class of type `T` and score
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          List<ClassificationResult<T>> getClasses(String text)
                                                   throws IOException

      Get all the classes (sorted by score, descending) assigned to the given text String.
      Parameters:
        `text` - a String containing text to be classified
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          List<ClassificationResult<T>> getClasses(String text,
                                                 int max)
                                                   throws IOException

      Get the first `max` classes (sorted by score, descending) assigned to the given text String.
      Parameters:
        `text` - a String containing text to be classified
        `max` - the number of return list elements
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Cut for "max" number of elements. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          void train(LeafReader leafReader,
                   String textFieldName,
                   String classFieldName,
                   Analyzer analyzer)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldName` - the name of the field used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          void train(LeafReader leafReader,
                   String textFieldName,
                   String classFieldName,
                   Analyzer analyzer,
                   Query query)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldName` - the name of the field used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
        `query` - the query to filter which documents use for training
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          void train(LeafReader leafReader,
                   String[] textFieldNames,
                   String classFieldName,
                   Analyzer analyzer,
                   Query query)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldNames` - the names of the fields to be used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
        `query` - the query to filter which documents use for training
      Throws:
        `IOException` - If there is a low-level I/O error.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.